# -*- coding: utf-8 -*-
"""
@author: Manuel
SPD Analysis
"""

import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.style
matplotlib.style.use('ggplot')
print(plt.style.available)
import numpy as np
from pandas.tools.plotting import scatter_matrix
import statsmodels.api as sm
import statsmodels.formula.api as smf

data = pd.read_csv("spd_dataset_interp.csv") # spd_dataset_interp; spd_full_dataset

print 'Arrow RT (mean +/- std):', data.arrow_response_time.mean(), data.arrow_response_time.std()
print 'pupil_response (mean +/- std):', data.pupil_response.mean(), data.pupil_response.std()

data['norm_max_diam'] = data.max_diam / data.pre_exp_baseline
data['norm_trial_baseline'] = data.trial_baseline / data.pre_exp_baseline
data['pupil_rate'] = data.max_diam / data.max_diam_time
data['promptness'] = 1.0 / data.arrow_response_time
data['arrow_peak_index'] = data.arrow_response_time / data.max_diam_time
data = data.loc[(data.arrow_peak_index < 3)]

plt.hist(data.arrow_peak_index)
plt.show()

print "norm_max_diam (M +/- STD): ", data.norm_max_diam.mean(), data.norm_max_diam.std()


# Check erotic effect
erotic_data = data.loc[(data.erotic==1), :]
#sliced_data.boxplot(column = 'valence_rating', by='age')

gb = data.groupby(('pid'))
print gb.arrow_response_time.mean(), gb.arrow_response_time.std()
exit()
# # # # # # # # # # # # # # # # #
#Scatter Matrix
# reduced_data = data.loc[:, ['arrow_peak_index', 'valence_absolute', 'subjective_absolute', 'arrow_response_time' ]]
# scatter_matrix(reduced_data, alpha=0.5,diagonal='kde')
# plt.suptitle('scatter-matrix')
#
# plt.show()


# # # # # # # # # # # # # #
#Linear Mixed Models
formula1 = "valence_absolute ~  pupil_response " # pupil_response   0.374     0.056   6.698  0.000   0.264   0.483
#formula1 = "valence_absolute ~  pupil " # b=.052, p<.000

formula2 = "pupil_response ~  valence_absolute + promptness " # pupil_response: b=.298, p=.005; arrow: b=3.612 p<.000
formula3 = "pupil_rate ~  valence_absolute + confidence_rating + subjective_absolute"

# Formula4: Important
formula4 = "pupil_response ~ + valence_absolute + confidence_rating + subjective_absolute + erotic + arrow_response_time" # !important

# Social Effects
formula5 = "pupil_response ~  condition + social_rating + social_influence_rating + social_distraction_rating + extro_intro_rating"
formula6 = "confidence_rating ~ condition + social_rating + social_influence_rating + social_distraction_rating + extro_intro_rating"

# The rt is predicted by confidence
formula7 = "arrow_response_time ~ confidence_rating + valence_absolute "

formula8 = " arrow_peak_index ~  valence_absolute"
#data = data.dropna()
md = smf.mixedlm( formula8 , data, groups=data["pid"])

mdf = md.fit()

print mdf.summary()

exit()

####
#data = data[data.pid != 1492677199] # Exclude one participant with very negative correlation
pids = data.groupby('pid')
ids = pids.groups.keys()
print ids

groups = data.groupby('pid')

min_valence = min(data.valence_absolute) # min(data.pupil_response)
max_valence = max(data.valence_absolute)

for p in ids:
    group = groups.get_group( p )

    z = np.polyfit(group.valence_absolute, group.pupil_response, 1)
    poly = np.poly1d(z)
    #print p, poly[1]
    plt.plot([min_valence, max_valence], [poly(min_valence), poly(max_valence)], 'gray', alpha = 0.7)

plt.title('Pupil Response Vs Perceived Valence ')
plt.xlabel('Perceived Valence')
plt.ylabel('Pupil Response (%)')
plt.show()


# Plots regression coefficient for all
# z = np.polyfit(data.valence_absolute, data.pupil_response, 1)
# p = np.poly1d(z)
# plt.plot([min_valence, max_valence], [p(min_valence), p(max_valence)])
# plt.show()


####

min_rt = min(data.arrow_response_time)
max_rt = max(data.arrow_response_time)

for p in ids:
    group = groups.get_group( p )

    z = np.polyfit(group.arrow_response_time, group.pupil_response, 1)
    poly = np.poly1d(z)
    #print p, poly[1]
    plt.plot([min_rt, max_rt], [poly(min_rt), poly(max_rt)])

plt.title('Pupil Response Vs Response Time ')
plt.xlabel('Arrow response time (s)')
plt.ylabel('Pupil Response (%)')
plt.show()
####

# plt.scatter(xrange(len(trials_data.pupil_response)), np.sort(trials_data.pupil_response))
# plt.show()
plt.scatter(data.valence_absolute, data.pupil_response, alpha = 0.2)
plt.show()

exit()
plt.scatter(data.arrow_response_time, data.max_diam)
plt.show()

plt.scatter(data.pupil_response, data.valence_response_time)
plt.show()
